import "./tasks/fastp.wdl" as fastp
workflow {{ project_name }} {	
	File inputSamplesFile
	Array[Array[File]] inputSamples = read_tsv(inputSamplesFile)
	String fastp_docker
	String adapter_sequence
	String adapter_sequence_r2
	String fastp_cluster
	String umi_loc	
	Int trim_front1 
	Int trim_tail1 
	Int max_len1 
	Int trim_front2 
	Int trim_tail2  
	Int max_len2 
	Int disable_adapter_trimming
	Int length_required
	Int umi_len
	Int UMI
	Int qualified_quality_phred
	Int length_required1
	Int disable_quality_filtering

	scatter (quartet in inputSamples){
		call fastp.fastp as fastp {
		input: 
		sample_id= quartet[2],
		read1= quartet[0], 
		read2= quartet[1],
		docker = fastp_docker,
		cluster = fastp_cluster,
		adapter_sequence = adapter_sequence,
    		adapter_sequence_r2 = adapter_sequence_r2,
		umi_loc = umi_loc,
		trim_front1 = trim_front1,
		trim_tail1 = trim_tail1, 
		max_len1  = max_len1,
		trim_front2  = trim_front2,
		trim_tail2   = trim_tail2,
		max_len2  = max_len2,
		disable_adapter_trimming = disable_adapter_trimming,
		length_required = length_required,
		umi_len = umi_len,
		UMI = UMI,
		qualified_quality_phred = qualified_quality_phred,
		length_required1 = length_required1,
		disable_quality_filtering = disable_quality_filtering
		}
	}
}